searchData={"content_type":"text/markdown","items":[{"doc":"","ref":"Request.Validator.html","title":"Request.Validator","type":"behaviour"},{"doc":"Determine if the user is authorized to make this request.\n```elixir\ndef authorize(conn) do\n  user(conn).is_admin\nend\n```","ref":"Request.Validator.html#c:authorize/1","title":"Request.Validator.authorize/1","type":"callback"},{"doc":"Get the validation rules that apply to the request.","ref":"Request.Validator.html#c:rules/1","title":"Request.Validator.rules/1","type":"callback"},{"doc":"","ref":"Request.Validator.html#validate/3","title":"Request.Validator.validate/3","type":"function"},{"doc":"","ref":"Request.Validator.html#t:validation_result/0","title":"Request.Validator.validation_result/0","type":"type"},{"doc":"","ref":"Request.Validator.DefaultRules.html","title":"Request.Validator.DefaultRules","type":"module"},{"doc":"","ref":"Request.Validator.DefaultRules.html#active_url/2","title":"Request.Validator.DefaultRules.active_url/2","type":"function"},{"doc":"","ref":"Request.Validator.DefaultRules.html#alpha_dash/2","title":"Request.Validator.DefaultRules.alpha_dash/2","type":"function"},{"doc":"","ref":"Request.Validator.DefaultRules.html#boolean/2","title":"Request.Validator.DefaultRules.boolean/2","type":"function"},{"doc":"","ref":"Request.Validator.DefaultRules.html#confirmed/2","title":"Request.Validator.DefaultRules.confirmed/2","type":"function"},{"doc":"","ref":"Request.Validator.DefaultRules.html#email/2","title":"Request.Validator.DefaultRules.email/2","type":"function"},{"doc":"","ref":"Request.Validator.DefaultRules.html#exists/3","title":"Request.Validator.DefaultRules.exists/3","type":"function"},{"doc":"","ref":"Request.Validator.DefaultRules.html#file/2","title":"Request.Validator.DefaultRules.file/2","type":"function"},{"doc":"","ref":"Request.Validator.DefaultRules.html#gt/3","title":"Request.Validator.DefaultRules.gt/3","type":"function"},{"doc":"","ref":"Request.Validator.DefaultRules.html#in_list/3","title":"Request.Validator.DefaultRules.in_list/3","type":"function"},{"doc":"","ref":"Request.Validator.DefaultRules.html#list/2","title":"Request.Validator.DefaultRules.list/2","type":"function"},{"doc":"","ref":"Request.Validator.DefaultRules.html#lt/3","title":"Request.Validator.DefaultRules.lt/3","type":"function"},{"doc":"","ref":"Request.Validator.DefaultRules.html#map/2","title":"Request.Validator.DefaultRules.map/2","type":"function"},{"doc":"","ref":"Request.Validator.DefaultRules.html#max/3","title":"Request.Validator.DefaultRules.max/3","type":"function"},{"doc":"","ref":"Request.Validator.DefaultRules.html#min/3","title":"Request.Validator.DefaultRules.min/3","type":"function"},{"doc":"","ref":"Request.Validator.DefaultRules.html#numeric/2","title":"Request.Validator.DefaultRules.numeric/2","type":"function"},{"doc":"","ref":"Request.Validator.DefaultRules.html#present_or_implicit_rules?/3","title":"Request.Validator.DefaultRules.present_or_implicit_rules?/3","type":"function"},{"doc":"","ref":"Request.Validator.DefaultRules.html#required/2","title":"Request.Validator.DefaultRules.required/2","type":"function"},{"doc":"","ref":"Request.Validator.DefaultRules.html#required_if/3","title":"Request.Validator.DefaultRules.required_if/3","type":"function"},{"doc":"","ref":"Request.Validator.DefaultRules.html#run_rule/3","title":"Request.Validator.DefaultRules.run_rule/3","type":"function"},{"doc":"","ref":"Request.Validator.DefaultRules.html#run_rule/4","title":"Request.Validator.DefaultRules.run_rule/4","type":"function"},{"doc":"","ref":"Request.Validator.DefaultRules.html#size/3","title":"Request.Validator.DefaultRules.size/3","type":"function"},{"doc":"","ref":"Request.Validator.DefaultRules.html#string/2","title":"Request.Validator.DefaultRules.string/2","type":"function"},{"doc":"","ref":"Request.Validator.DefaultRules.html#unique/3","title":"Request.Validator.DefaultRules.unique/3","type":"function"},{"doc":"","ref":"Request.Validator.DefaultRules.html#url/2","title":"Request.Validator.DefaultRules.url/2","type":"function"},{"doc":"","ref":"Request.Validator.Helper.html","title":"Request.Validator.Helper","type":"module"},{"doc":"A wrapper around the `{:exists, callback}` rule.","ref":"Request.Validator.Helper.html#exists/1","title":"Request.Validator.Helper.exists/1","type":"function"},{"doc":"iex> alias Request.Validator.Helper\n    Request.Validator.Helper\n    iex> {:exists, _} = Helper.exists(&(&1 == 10))","ref":"Request.Validator.Helper.html#exists/1-examples","title":"Examples - Request.Validator.Helper.exists/1","type":"function"},{"doc":"A wrapper around the `{:gt, field}` rule.","ref":"Request.Validator.Helper.html#gt/1","title":"Request.Validator.Helper.gt/1","type":"function"},{"doc":"iex> Request.Validator.Helper.gt(:age)\n    {:gt, :age}\n    iex> Request.Validator.Helper.gt(:year)\n    {:gt, :year}","ref":"Request.Validator.Helper.html#gt/1-examples","title":"Examples - Request.Validator.Helper.gt/1","type":"function"},{"doc":"A wrapper around the `{:in_list, options}` rule.","ref":"Request.Validator.Helper.html#in_list/1","title":"Request.Validator.Helper.in_list/1","type":"function"},{"doc":"iex> Request.Validator.Helper.in_list([\"male\", \"female\"])\n    {:in_list, ~w[male female]}\n    iex> Request.Validator.Helper.in_list(~w[tech law finance])\n    {:in_list, [\"tech\", \"law\", \"finance\"]}\n    iex> Request.Validator.Helper.in_list(~w[doctor nurse nurse midwife specialist midwife doctor])\n    {:in_list, ~w[doctor nurse midwife specialist]}","ref":"Request.Validator.Helper.html#in_list/1-examples","title":"Examples - Request.Validator.Helper.in_list/1","type":"function"},{"doc":"A wrapper around the `{:lt, field}` rule.","ref":"Request.Validator.Helper.html#lt/1","title":"Request.Validator.Helper.lt/1","type":"function"},{"doc":"iex> Request.Validator.Helper.lt(:age)\n    {:lt, :age}\n    iex> Request.Validator.Helper.lt(:year)\n    {:lt, :year}","ref":"Request.Validator.Helper.html#lt/1-examples","title":"Examples - Request.Validator.Helper.lt/1","type":"function"},{"doc":"A wrapper around the `{:max, value}` rule.","ref":"Request.Validator.Helper.html#max/1","title":"Request.Validator.Helper.max/1","type":"function"},{"doc":"iex> Request.Validator.Helper.max(30)\n    {:max, 30}\n    iex> Request.Validator.Helper.max(40)\n    {:max, 40}","ref":"Request.Validator.Helper.html#max/1-examples","title":"Examples - Request.Validator.Helper.max/1","type":"function"},{"doc":"A wrapper around the `{:min, value}` rule.","ref":"Request.Validator.Helper.html#min/1","title":"Request.Validator.Helper.min/1","type":"function"},{"doc":"iex> Request.Validator.Helper.min(30)\n    {:min, 30}\n    iex> Request.Validator.Helper.min(40)\n    {:min, 40}","ref":"Request.Validator.Helper.html#min/1-examples","title":"Examples - Request.Validator.Helper.min/1","type":"function"},{"doc":"Makes a nested map input validation nullable.","ref":"Request.Validator.Helper.html#nullable/1","title":"Request.Validator.Helper.nullable/1","type":"function"},{"doc":"iex> alias Request.Validator.{Helper, Rules}\n    [Request.Validator.Helper, Request.Validator.Rules]\n    iex> Helper.nullable(Rules.map(name: ~w[required string]a))\n    %Rules.Object{attrs: [name: ~w[required string]a], nullable: true}\n    iex> Rules.map(name: ~w[required string]a)\n    %Rules.Object{attrs: [name: ~w[required string]a], nullable: false}","ref":"Request.Validator.Helper.html#nullable/1-examples","title":"Examples - Request.Validator.Helper.nullable/1","type":"function"},{"doc":"A wrapper around the `required` rule.","ref":"Request.Validator.Helper.html#required/1","title":"Request.Validator.Helper.required/1","type":"function"},{"doc":"iex> Request.Validator.Helper.required(:string)\n    ~w[required string]a\n    iex> Request.Validator.Helper.required([:string, :email, {:max, 100}])\n    [:required, :string, :email, {:max, 100}]\n    iex> Request.Validator.Helper.required({:max, 100})\n    [:required, {:max, 100}]","ref":"Request.Validator.Helper.html#required/1-examples","title":"Examples - Request.Validator.Helper.required/1","type":"function"},{"doc":"A wrapper around the `{:size, value}` rule.","ref":"Request.Validator.Helper.html#size/1","title":"Request.Validator.Helper.size/1","type":"function"},{"doc":"iex> Request.Validator.Helper.size(30)\n    {:size, 30}\n    iex> Request.Validator.Helper.size(40)\n    {:size, 40}","ref":"Request.Validator.Helper.html#size/1-examples","title":"Examples - Request.Validator.Helper.size/1","type":"function"},{"doc":"A wrapper around the `{:unique, callback}` rule.","ref":"Request.Validator.Helper.html#unique/1","title":"Request.Validator.Helper.unique/1","type":"function"},{"doc":"iex> alias Request.Validator.Helper\n    Request.Validator.Helper\n    iex> {:unique, _} = Helper.unique(&(&1 == 10))","ref":"Request.Validator.Helper.html#unique/1-examples","title":"Examples - Request.Validator.Helper.unique/1","type":"function"},{"doc":"","ref":"Request.Validator.Plug.html","title":"Request.Validator.Plug","type":"module"},{"doc":"Performs validations on `conn.params`\nIf all validations are successful returns the connection struct\nOtherwise returns an error map in the following structure: `%{param: [\"some error\", ...]}`\nWill call the given `on_error` callback in case some validation failed","ref":"Request.Validator.Plug.html#call/2","title":"Request.Validator.Plug.call/2","type":"function"},{"doc":"Init the Request.Validator.Plug with an optional error callback\nand handlers with their corresponding request validator module.\n```elixir\nplug Request.Validator.Plug,\n  register: App.Requests.RegisterRequest,\n  on_error: fn conn, errors -> json_resp(conn, \"Handle your errors: #{inspect errors}\") end\n```","ref":"Request.Validator.Plug.html#init/1","title":"Request.Validator.Plug.init/1","type":"function"},{"doc":"The default callback to be invoked when there is a param that fails validation.","ref":"Request.Validator.Plug.html#on_error/2","title":"Request.Validator.Plug.on_error/2","type":"function"},{"doc":"","ref":"Request.Validator.Rules.html","title":"Request.Validator.Rules","type":"module"},{"doc":"","ref":"Request.Validator.Rules.html#array/1","title":"Request.Validator.Rules.array/1","type":"function"},{"doc":"","ref":"Request.Validator.Rules.html#bail/1","title":"Request.Validator.Rules.bail/1","type":"function"},{"doc":"","ref":"Request.Validator.Rules.html#map/1","title":"Request.Validator.Rules.map/1","type":"function"},{"doc":"","ref":"Request.Validator.Rules.Array.html","title":"Request.Validator.Rules.Array","type":"module"},{"doc":"","ref":"Request.Validator.Rules.Array.html#t:t/0","title":"Request.Validator.Rules.Array.t/0","type":"type"},{"doc":"","ref":"Request.Validator.Rules.Bail.html","title":"Request.Validator.Rules.Bail","type":"module"},{"doc":"","ref":"Request.Validator.Rules.Bail.html#t:t/0","title":"Request.Validator.Rules.Bail.t/0","type":"type"},{"doc":"","ref":"Request.Validator.Rules.Object.html","title":"Request.Validator.Rules.Object","type":"module"},{"doc":"","ref":"Request.Validator.Rules.Object.html#t:t/0","title":"Request.Validator.Rules.Object.t/0","type":"type"},{"doc":"# RequestValidator\n\nA blazing fast request validator for your phoenix app, which validates a request body before hitting the request handler in the controller.\n\n- [Why RequestValidator](#why-request-validator)\n- [Installation](#installation)\n- [Usage](#usage)\n- [Ecto Support](#ecto-support)\n- [Custom Validation Rules](#custom-validation-rules)","ref":"readme.html","title":"RequestValidator","type":"extras"},{"doc":"It's common for a web service to validate incoming data. The most common layer where this is done is at the controller level and this sometimes leads to having a bloated controller. But with RequestValidator, you move the validation logic to a layer just before the controller and your controller is now free from doing validation.","ref":"readme.html#why-requestvalidator","title":"Why RequestValidator - RequestValidator","type":"extras"},{"doc":"The package can be installed by adding `request_validator` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:request_validator, \"~> 0.8.4\"}\n  ]\nend\n```","ref":"readme.html#installation","title":"Installation - RequestValidator","type":"extras"},{"doc":"First of all, you need to define a validation schema to be used against the incoming data.\n\n```elixir\ndefmodule App.Requests.Registration do\n  use Request.Validator\n  \n  # Get the validation rules that apply to the incoming request.\n  @impl Request.Validator\n  def rules(_) do\n    [\n      email: ~w[required email]a,\n      first_name: ~w[required string]a,\n      last_name: ~w[required string]a,\n      password: [:required, :string, {:min, 8}, :confirmed]\n    ]\n  end\n\n  # Determine if the user is authorized to make this request.\n  @impl Request.Validator\n  def authorize(_), do: true\nend\n```\n\nThe above validation schema can now be used;\n\n```elixir\ndefmodule App.UserController do\n  use AppWeb, :controller\n\n  plug Request.Validator.Plug,\n    register: App.Requests.Registration\n\n  def register(conn, params) do\n    case App.UserService.create(params) do\n      :ok ->\n        conn\n        |> put_status(201)\n        |> json(%{message: \"Account created successfully\"})\n      {:error, msg} ->\n        conn\n        |> put_status(500)\n        |> json(%{message: msg})\n    end\n  end\nend\n```\n\nAs you can see in the controller, the `register` handler does not need to worry about validating the incoming request because `RequestValidator` will handle that automatically and send the right response if the request fails validation based on the given validation schema.\n\nYou can specify validation schema for each of the handlers in a controller:\n\n```elixir\ndefmodule App.UserController do\n  use AppWeb, :controller\n\n  plug Request.Validator.Plug,\n    login: App.Requests.Login,\n    register: App.Requests.Registration\n\n  ...\nend\n```\n\nFull documentation can be found at [https://hexdocs.pm/request_validator](https://hexdocs.pm/request_validator).","ref":"readme.html#usage","title":"Usage - RequestValidator","type":"extras"},{"doc":"In some cases, your application already makes use of the ecto library. I'm glad to tell you that this library has support when the rule method returns an `Ecto.Changeset` struct so that you can\nmake use of the advantages provided by this library without rewriting your validation logic. See the example below:\n\n```elixir\ndefmodule App.SomeEctoSchema do\n  use Ecto.Schema\n  import Ecto.Changeset\n\n  embedded_schema do\n    field(:name, :string)\n    field(:email, :string)\n    field(:age, :integer)\n    field(:password, :string)\n  end\n\n  @doc false\n  def changeset(attrs), do: changeset(%__MODULE__{}, attrs)\n\n  @doc false\n  def changeset(struct, attrs) do\n    struct\n    |> cast(attrs, [:name, :email, :age, :password])\n    |> validate_required([:name, :email, :age, :password])\n    |> validate_number(:age, less_than_or_equal_to: 32)\n  end\nend\n\ndefmodule App.Requests.TestRequest do\n  use Request.Validator\n\n  alias App.SomeEctoSchema\n\n  @impl Request.Validator\n  def rules(conn), do: SomeEctoSchema.changeset(conn.params)\n\n  @impl Request.Validator\n  def authorize(_), do: true\nend\n```","ref":"readme.html#ecto-support","title":"Ecto Support - RequestValidator","type":"extras"},{"doc":"This library provides a variety of helpful rules, however, you might want to define some rules to house your validation logic. To achieve this, you need to create your own rules module, extend the default rules and update the library configuration;\n\n```elixir\ndefmodule App.Validation.Rules do\n  use Request.Validator.Rules # grab default rules provided by the library\n\n  @spec uppercase(binary(), keyword()) :: :ok | {:error, binary()}\n  def uppercase(value, fields: _fields, field: _field) do\n    case String.upcase(value) do\n      ^value ->\n        :ok\n      _ ->\n        {:error, \"This field must be uppercase.\"}\n    end\n  end\nend\n```\n\nAfter defining a module with your custom rules, you will need to update your application configuration:\n\n```elixir\nconfig :request_validator, rules_module: App.Validation.Rules\n```\n\nOnce the new rule has been added and configuration updated, it can now be used:\n\n```elixir\n# ...\n  def rules(_) do\n    [\n      name: ~w[required string uppercase]a\n    ]\n  end\n# ...\n```\n\nNote that if your rule accepts options/parameters, its function definition should have an arity of 3, and the second argument will be the option provided when the rule is used, ex: `{:custom_rule, options}`","ref":"readme.html#custom-validation-rules","title":"Custom Validation Rules - RequestValidator","type":"extras"},{"doc":"#","ref":"readme.html#available-rules","title":"Available Rules - RequestValidator","type":"extras"},{"doc":"The field under validation must have a valid AAAA or A record. This check is done using `:inet.gethostbyname`\n\n#","ref":"readme.html#active_url","title":"active_url - RequestValidator","type":"extras"},{"doc":"The field under validation may have alpha-numeric characters, as well as dashes and underscores\n\n#","ref":"readme.html#alpha_dash","title":"alpha_dash - RequestValidator","type":"extras"},{"doc":"The field under validation must be able to be cast as a boolean. Accepted input are `true`, `false`, `1`, `0`, `\"1\"`, and `\"0\"`.\n\n#","ref":"readme.html#boolean","title":"boolean - RequestValidator","type":"extras"},{"doc":"The field under validation must have a matching field of `{field}_confirmation`. For example, if the field under validation is `password`, a matching `password_confirmation` field must be present in the input.\n\n#","ref":"readme.html#confirmed","title":"confirmed - RequestValidator","type":"extras"},{"doc":"The field under validation must be a valid email. This rule utilizes the `email_checker` library. By default it checks for email format and mx record to make sure the email does exists.\n\n### {exists, callback}\n\nThe field under validation must exist in a datastore. See sample usage below:\n\n```elixir\nreference: [:required, :alpha_dash, min(2), max(20), {:exists, &reference_exists?/2}]\n# ...\ndefp reference_exists?(tx_no, _opts) do\n  Payments.get_by_reference(tx_no))\nend\n```\n\n#","ref":"readme.html#email","title":"email - RequestValidator","type":"extras"},{"doc":"The field under validation must be a successfully uploaded file by checking if the field is a `Plug.Upload` struct.\n\n### {gt, field}\n\nThe field under validation must be greater than the given field. The two fields must be of the same type. Strings, numerics and lists are evaluated using the same conventions as the [size](#size) rule.\n\n```elixir\ninvestment: [:required, :numeric],\nreturn_on_investment: [:required, {:gt, :investment}]\n```\n\n### {in_list, options}\n\nThe field under validation must be included in the given list of values.\n\n```elixir\nregion: [:required, {:in_list, ~w[us-east-2 us-east-1 us-west-1 us-west-2]}]\n```\n\n#","ref":"readme.html#file","title":"file - RequestValidator","type":"extras"},{"doc":"The field under validation must be an Elixir `list`.\n\n### {lt, field}\n\nThe field under validation must be less than the given field. The two fields must be of the same type. Strings, numerics and lists are evaluated using the same conventions as the [size](#size) rule.\n\n```elixir\nestimated_churn_rate: [:required, :numeric],\nchurn_rate: [:required, {:lt, :estimated_churn_rate}]\n```\n\n#","ref":"readme.html#list","title":"list - RequestValidator","type":"extras"},{"doc":"The field under validation must be an Elixir `map`.\n\n### {max, value}\n\nThe field under validation must be less than or equal to a maximum value. Strings, numerics and lists are evaluated in the same fashion as the [size](#size) rule.\n\n### {min, value}\n\nThe field under validation must have a minimum value. Strings, numerics and lists are evaluated in the same fashion as the [size](#size) rule.\n\n#","ref":"readme.html#map","title":"map - RequestValidator","type":"extras"},{"doc":"The field under validation must be numeric based on `is_number`.\n\n#","ref":"readme.html#numeric","title":"numeric - RequestValidator","type":"extras"},{"doc":"The field under validation must be present in the input data and not empty. A field is considered \"empty\" if one of the following conditions are true:\n\n* The value is null.\n* The value is an empty string.\n* The value is an empty list or map.\n\n### {size, value}\n\nThe field under validation must have a size matching the given _value_.\n\n```elixir\n# Validate that a string is exactly 12 characters long...\ntitle: [{:size, 12}]\n\n# Validate that a provided integer equals 10...\nseats: [:numeric, {:size, 10}]\n\n# Validate that an list has exactly 5 elements...\ntags: [:list, {:size, 5}]\n```\n\n#","ref":"readme.html#required","title":"required - RequestValidator","type":"extras"},{"doc":"The field under validation must be a string.\n\n### {unique, callback}\n\nThe field under validation must not exist within the a datastore. See sample usage below:\n\n```elixir\nusername: [:required, :alpha_dash, min(2), max(20), {:unique, &is_unique_username?/2}]\n# ...\ndefp is_unique_username?(username, _opts) do\n  is_nil(Accounts.get_user_by_username(username))\nend\n```\n\n#","ref":"readme.html#string","title":"string - RequestValidator","type":"extras"},{"doc":"The field under validation must be a valid URL.","ref":"readme.html#url","title":"url - RequestValidator","type":"extras"},{"doc":"See [content](https://hexdocs.pm/request_validator/Request.Validator.Helper.html#content).","ref":"readme.html#helper-functions","title":"Helper Functions - RequestValidator","type":"extras"},{"doc":"Validating nested map input shouldn't be a problem. For example the HTTP request contains `address` field which is a map with nested attributes (`line1`, `line2`...), you may validate it like so:\n\n```elixir\naddress: map(\n  line1: [:required, :string, {:max, 100}],\n  city: [:required, :string, {:max, 50}],\n  zip_code: [:required, :string, {:max, 10}],\n  country: [:required, :string, {:max, 60}],\n  line2: [:string, {:max, 100}],\n  state: [:string, {:max, 50}]\n)\n```","ref":"readme.html#validating-nested-input","title":"Validating Nested Input - RequestValidator","type":"extras"},{"doc":"- [ ] Include more validation rules\n- [ ] Norm validation support\n- [x] Ecto schema support","ref":"readme.html#todos","title":"TODOS - RequestValidator","type":"extras"},{"doc":"RequestValidator is released under the MIT License - see the [LICENSE](LICENSE) file.","ref":"readme.html#license","title":"License - RequestValidator","type":"extras"},{"doc":"MIT License\n\nCopyright (c) 2020 atanda rasheed\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]}